#ifndef _webdisp_h    // Put these two lines at the top of your file.
#define _webdisp_h

// *** extra pin definitions - most handled in library ***
const int buttonPin = 26; // is GPIO26
const int switchPin = 25; // is GPIO25
bool buttonState, lastButtonState, switchState, lastSwitchState; //have they changed?

/* Configuration of NTP */
#define MY_NTP_SERVER "pool.ntp.org"         
#define MY_TZ "GMT0"  //not working - not used

//  *** loop timing  ***
unsigned long timeWas, timeNow;
//NB timeInterval MUST be much greater than pingNumber * pingTrip due to a long delay in the library
int timeInterval = 6; // in seconds.  The repeat must be  an integer fraction of 60 sec so eg 2,5,6,10,12 etc (see next line)
int samples; //samples set to (60 / timeInterval) in setup for use in pingstats

// *** ping handling and stats
int pingNumber = 2; //do pingNumber pings per set; set to 1 for no averaging
int pingTrip = 200; //
unsigned long  countUp = 0;  //at eg 30 days countUp could be samples * 30 * 24 * 60 = 200,000
unsigned long  countDown = 0;
unsigned long minsUp, minsDown; //minsUp = countUp * timeInterval/60 so at eg 30 days minsUp could be 30 * 24 * 60 = 43,200
int hhUp, hhDown, ddUp, ddDown;  //esp8266 uses 32 bits  for integers
int lineDown; //flags web fail
int threshold = 3; //number of successive fails to decide a lineDown
int pingsLost; 

// recording ping statistics in usec
long pingTime; //holds values in usec: could be a big number
unsigned long   pingAvg = 0; //start value for averaging is taken from first successful ping
long   pingLast = 40000; //values for calculating quality
unsigned long   pingJitter = 1000; //start value for average ping jitter = 1msec - quality metric starts near 99%
long   diff; //successive difference between pings

//ping stats in msec
int pingAvgm;

//these need to be matched to timeInterval - these are for a 5 sec
const int pingFilterS = 1;   // no averaging
const int pingFilterL = 6;   // time const 1 min: geometric moving average

const int qualFilterS = 6;   //time const 1 min: faster response if quality OK 
const int qualFilterL = 30;  //time const 5 min: good averaging if ping slow & lots jitter

int pingFilter = 1, qualFilter = 1; //default values for testing - no averaging if checkSwitches is not active
int pingFilterM1, qualFilterM1;  //above -1 for average calcs

float pingQual; //my % metric for line quality



// *** display values ***
int xpos; //current x position
bool showDone = false;
//strings for display
char sTitle[] = "Weblog 2.05 L"; 
char sTitleL[] = "Weblog 2.05 L";  
char sTitleS[] = "Weblog 2.05 S";
//buffers used in pingStats - these characters just set the size of the buffer 
char spAvg[] = "ping time: xxx ms ";
char sqAvg[] = "quality: xx ms% ";
char stUp[] = "up00d00h00m   ";
char stDown[] = "dn00d00h00m   ";

//time & date variables
char dayStamp[12], timeStamp[12]; //dayStamp = yyyy/mm/dd  Timestamp = hh/mm/ss
String myFormattedDate;
int YYYY, MM, DD, hh, mm, ss;  //integer values for current date and time
int today;  //check for day change to write new headline to file
int thisMonth; //check to see if we need to delete last years record for the same month
String lastYear; //to make filename for last years month file
String sYear, sMonth;  //name to build file for new month

#endif // _weblog_h 
